function  Phi = eval_Phi(samples,gpcmodel,order)
%	compute the Basis value at some sampling point
    assert(order<=2*gpcmodel.order)
    [nsmp,d] = size(samples); 
    N_order = nchoosek(order+d,d);
    if order == gpcmodel.order
        BasisCoeff = gpcmodel.BasisCoeff;
    elseif order == 2*gpcmodel.order
        BasisCoeff = gpcmodel.BasisCoeff_2p;
    else
        BasisCoeff = gpcmodel.BasisCoeff_2p;
        BasisCoeff = BasisCoeff(1:N_order,1:N_order);
    end
    
    Phi = ones(nsmp,N_order); 
    cind = 2;
    for n = 1:order
        pow = monomial_pow(n,d);
        cnum = size(pow,1);
        tmp = samples(:,pow(:,1));
        for ipow = 2:n
            tmp = tmp.*samples(:,pow(:,ipow));
        end
        Phi(:,cind:cind+cnum-1) = tmp; 
        cind = cind + cnum;
    end
    Phi = BasisCoeff*Phi';
    
    function pow  = monomial_pow(n,d)
    % the monomials of all polynomials with 
    % dimension = d, and order = n
    % via graded lexicographic order 
    
        pow = nchoosek(1:n-1+d,n);
        for j = 1:n
            pow(:,j) = pow(:,j)-j+1;
        end  
        
    end
end